%%% bumelka-not
%%% Prosty program ilustrujący użycie predykatu not (w notacji prologu \+)


% Duża baza przypadków pozytywnych
  pracownik(adam).
  pracownik(bogdan).
  pracownik(czesiek).
  pracownik(damian).
  pracownik(eustachy).
  pracownik(walery).
  pracownik(xawery).
  pracownik(zbigniew). 


% Niewielka (relatywnie) liczba wyjątków
  bumelka(bogdan).
  bumelka(walery).
  bumelka(damian).

% Definicja celu  
  premia(X):-
     pracownik(X),
     not(bumelka(X)).
 premia2(X):-
     not(bumelka(X)),
       pracownik(X).
%inna definicja: w not trzeba używać stałych, nie zmiennych.
  pracowity(X):-
     bumelka(X),!,
     fail.
  pracowity(_).
   
w:- pracownik(X),write(X),nl, pracowity(X),write('*** '), write(X),nl,fail.

%%% eof
