/***  hugetree.pro  - benchmark   ***/

%% huge_tree = example huge tree

%% A benchmark program


:- dynamic(t/2).

% test(N,H,M,S,P):-
%   huge_tree(N,X),
%   huge_tree(N,Y),
%   time(H1,M1,S1,P1),X=Y,time(H2,M2,S2,P2),
%   H is H2-H1,M is M2-M1,S is S2-S1,P is P2-P1.

test(N):-
   huge_tree(N,X),
   huge_tree(N,Y),
   X=Y % , write(X)
   .
	
  
huge_tree(0,tree(i(0),i(0),i(0),i(0),i(0),i(0),i(0),i(0),i(0),i(0))).
huge_tree(N,tree(X,X,X,X,X,X,X,X,X,X)):-
  N > 0,
  N1 is N-1, 
  huge_tree(N1,X).  

hta(N,T):- huge_tree(N,Tree), assert(t(T,Tree)).

nodes(T,N):- t(T,Tree), cn(Tree,N).
cn(tree(i(0),i(0),i(0),i(0),i(0),i(0),i(0),i(0),i(0),i(0)),10).
cn(tree(T,_,_,_,_,_,_,_,_,_),W):- cn(T,N), W is N*10.
