%%% Naiwne sortowanie przez permutacje



perm([],[]).
perm([G|Ogon],Wynik):-
		perm(Ogon,W1),
		wstaw(G,W1,Wynik).
wstaw(X,[],[X]):- !.
wstaw(X,L,[X|L]).
wstaw(X,[P|L],[P|LX]):- wstaw(X,L,LX).



permutation([],[]).
permutation([G|Ogon],Wynik):-
		permutation(Ogon,W1),
		insert(G,W1,Wynik).

insert(Y,XZ,XYZ):- append(X,Z,XZ),append(X,[Y|Z],XYZ).



sorted([]):- !.
sorted([_]):- !.
sorted([X,Y|T]) :- X =< Y, sorted([Y|T]).

nsort(L,S):-
	perm(L,S),
	sorted(S).

slowsort(L,S):-
	permutation(L,S),
	sorted(S).

p([],[]).
p([H|T],P):- p(T,PT), append(F,B,PT),append(F,[H|B],P).
