 % Wprowadzenie do list: termy rekurencyjne

% Znane języki obce definiujemy jako term rekurencyjny: l(jezyk,<term>|nic)



osoba(jan,nic).
osoba(adam,l(angielski,nic)).
osoba(pawel,l(angielski,l(francuski,nic))).
osoba(walery,l(niemiecki,l(angielski,l(francuski,nic)))).

%przyk³adowe procedury

 %wypisywanie wszystkiego
all :-
       osoba(Imie,_),
       zna_jezyki(Imie),
       fail.
         
 zna_jezyki(Imie):-
      osoba(Imie,nic),!, write(Imie), write(' nie zna jezykow'),nl.
 zna_jezyki(Imie):-
      osoba(Imie,l(Jezyk,Reszta)), 
      wypisz(Imie,Jezyk,Reszta).

wypisz(Imie,Jezyk,nic):-
      !, write(Imie), write(' zna '), write(Jezyk),nl.
wypisz(Imie,Jezyk1,l(Jezyk2,Reszta)):-
      write(Imie), write(' zna '), write(Jezyk1),nl,
      wypisz(Imie,Jezyk2,Reszta).
         
