
%%% ILustracje ptli w Prologu

% Fakty: definicja dostepnych cyfr. 
   cyfra(0).
   cyfra(1).
   cyfra(2).
   cyfra(3).
   cyfra(4).
   cyfra(5).   
   cyfra(6).
   cyfra(7).
   cyfra(8).
   cyfra(9).

%%% Znajd wszystkie rozwizania speniajace okreslony warunek w(X).

w(X):- X > 4, X < 9.

%%% Rozwizanie bezporednie

find(X):- cyfra(X),w(X).


%%% Klasyczna rekurencja
findrec(L):-
   findall(C,cyfra(C),LC),
   gorec(LC,L).
gorec([],[]).
gorec([H|T],[H|TN]):- gorec(T,TN),not(member(H,TN)),w(H),!.
gorec([_|T],TN):- gorec(T,TN).


%%% Ptla typu "koniec woa pocztek". Uycie !.
loop(L):-
     cyfra(C), 		% generate solution
     w(C),		% test solution
     not(member(C,L)),	% exliminate repetitions
     loop([C|L]), !.	% iteration with new state
loop(L):- write(L),nl.

% loop:- 
%      repeat/repete,
%      coc,
%      fail/test.


%%% Ptla repeat-fail. Wymaga modyfikowania pamici, dziaa bez koca. (monitoring)
looprf:-
   repeat,
   find(X),
   write(X),
   nl,
   fail.


%%% Ptla find-fail. Zawsze od pocztku. Generuje wszystkie rozwizania. Wymaga domknicia. Prawidowe wykorzystanie stosu i mechanizmw nawrotu w Prologu.
loopff:-

   find(X),
   write(X),
   nl,
   fail.
loopff.


%%% Ptla repeat-test. Generuje wszystkie rozwizania. Moliwe nawroty na repeat. (Nie obrazuje problemu - brak nawrotow na repeat). Wyjcie z ptli "dolem"
looprt:-
   repeat,
   find(X),
   write(X),
   nl,
   test(X).

test(X):- X < 8, !, fail.
test(X):- X==8, write('koniec').


%%% Ptla find-test. Generuje wszystkie rozwizania. Wyjcie z ptli "doem"
loopft:-

   find(X),
   write(X),
   nl,
   test(X),!.











