%%% list split equal: lse/6
%%% lse(L,L1,L2,W1,W2,l/p).


lse([],W1,W2,W1,W2,_):- !.
lse([H|T],L1,L2,W1,W2,l):- lse(T,[H|L1],L2,W1,W2,p), !.
lse([H|T],L1,L2,W1,W2,p):- lse(T,L1,[H|L2],W1,W2,l), !.

split([],[],[]).
split([H|T],[H|U],V):- split(T,V,U).

merge([H1|T1],[H2|T2],[H1|T]):-
   H1 < H2, !,
   merge(T1,[H2|T2],T).
merge([H1|T1],[H2|T2],[H2|T]):-
   merge([H1|T1],T2,T),!.
merge(X,[],X):-!.
merge([],X,X).

mergesort([],[]):- !.
mergesort([H],[H]):- !.
mergesort(L,S):-
   split(L,LL,LR),
   mergesort(LL,SLL),
   mergesort(LR,SLR),
   merge(SLL,SLR,S).

